#!/usr/bin/env python

from simplex import *
import sys, time

class IndexWriter:

    "A tab-delimited file writer."

    def __init__(self, f):
        self.f = f

    def append(self, entry):
        key, pos = entry
        entry = key + [pos]
        self.f.write("\t".join(map(str, entry)) + "\n")

try:
    filename, numeric, interval, index_filename = sys.argv[1:5]
    fields = map(int, sys.argv[5:])
    numeric = numeric == "true"
except (IndexError, ValueError):
    print >>sys.stderr, "Usage: %s <filename> <numeric> <interval> <index> <field>..." % sys.argv[0]
    sys.exit(1)

f = open(filename)
fi = open(index_filename, "w")
accessor = DelimitedRecord(fields, numeric=numeric)
writer = IndexWriter(fi)

try:
    t = time.time()
    make_index(f, accessor.get_key, int(interval), writer)
    print "Indexed in %s seconds." % (time.time() - t)

finally:
    f.close()
    fi.close()

# vim: tabstop=4 expandtab shiftwidth=4
